package com.sky.ioc.service.space.impl;

import com.sky.ioc.entity.domain.carbon.CarbonQuota;
import com.sky.ioc.entity.domain.space.Building;
import com.sky.ioc.mapper.CuisineMapper;
import com.sky.ioc.mapper.CuisineOderItemMapper;
import com.sky.ioc.mapper.job.TokenMapper;
import com.sky.ioc.mapper.space.BuildingMapper;
import com.sky.ioc.service.space.BuildingService;
import com.sky.ioc.tool.ReturnMsg;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpMethod;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.ThreadLocalRandom;

@Service
@Slf4j
public class BuildingServiceImpl implements BuildingService {

    @Autowired
    TokenMapper tokenMapper;

    @Value("${sky.dataIp}")
    private String dataIp;

    @Autowired
    BuildingMapper buildingMapper;

    final static  String BUILDING_URL="%s/api/space/SPACE/buildingArea/list";

    @Override
    public ReturnMsg getBuildigData() {
        String url =   String.format(BUILDING_URL,"http://"+dataIp)+"?pageNum=1&pageSize=1000";
        Map<String,String> tokenMap = tokenMapper.getNewToken();
        String token ="Bearer eyJhbGciOiJIUzUxMiJ9.eyJ1c2VyX2lkIjoxLCJ1c2VyX2tleSI6IjUwZTU1NTRkLWJjYzYtNGRhMS1iZDUxLWFhNTc3YzU4YTFiNCIsInVzZXJuYW1lIjoiYWRtaW4ifQ.X10VPYJfeeRTka7OtqNPOGMpL4QkW3fR_TfCKXCmO-yXbIIrr_40fcwiVnpXfYVENo_BvXWEACRd-Y6nXsbkog";
        if(tokenMap!=null){
            token = "Bearer "+tokenMap.get("token");
        }
        // 创建一个请求头对象
        HttpHeaders httpHeaders = new HttpHeaders();
        // 设置参数
        httpHeaders.set("authorization", token);
        // 创建一个响应体对象
        HttpEntity<String> httpEntity = new HttpEntity(httpHeaders);
        // 3.创建RestTemplate
        RestTemplate restTemplate = new RestTemplate();
        // 发送GET请求
        ResponseEntity<Map> responseEntity = restTemplate.exchange(url, HttpMethod.GET, httpEntity, Map.class);
        // 获取响应对象里的 body 对象
        Map<String, Object> body = responseEntity.getBody();
        // 获取状态码
        Integer code = (Integer)body.get("code");
        // 获取响应信息
        String message = (String)body.get("msg");
        if(code==200){
            ThreadLocalRandom random = ThreadLocalRandom.current();
            ArrayList list = (ArrayList) body.get("rows");
            if(list!=null&&list.size()>0){
                buildingMapper.delete(null);
                for (int i=0;i<list.size();i++){
                    LinkedHashMap json = (LinkedHashMap) list.get(i);
                    Building building = new Building();
                    building.setId((Integer) json.get("id"));
                    building.setType(String.valueOf(json.get("buildingType")));
                    building.setName(String.valueOf(json.get("name")));
                    if(json.get("buildingArea")!=null){
                        building.setBuildingArea(String.valueOf(json.get("buildingArea")));
                    }
                    if(json.get("usableArea")!=null){
                        building.setUseableArea(String.valueOf(json.get("usableArea")));
                    }
                    if(json.get("enterTime")!=null){
                        building.setEnterTime(String.valueOf(json.get("enterTime")));
                    }
                    buildingMapper.insert(building);
                }
            }
            return ReturnMsg.ok();

        }else{
            log.info("获取碳配额数据："+message);
            return  ReturnMsg.fail(message);
        }
    }

    @Override
    public ReturnMsg listBuilding() {
        List<Building> list = buildingMapper.selectList(null);
        return ReturnMsg.ok(list);
    }
}
