package com.sky.ioc.service.space.impl;

import com.sky.ioc.entity.domain.space.BuildingStation;
import com.sky.ioc.mapper.job.TokenMapper;
import com.sky.ioc.mapper.space.BuildingStationMapper;
import com.sky.ioc.service.space.BuildingStationService;
import com.sky.ioc.tool.ReturnMsg;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpMethod;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.Map;

@Service
@Slf4j
public class BuildingStationServiceImpl implements BuildingStationService {

    @Autowired
    BuildingStationMapper buildingStationMapper;

    @Autowired
    TokenMapper tokenMapper;

    final static  String BUILDING_STATION_URL="http://192.168.1.45:9001/api/space/SPACE/cellArea/list?pageNum=1&pageSize=90000";


    @Override
    public ReturnMsg getBuildingStationList() {
        Map<String,String> tokenMap = tokenMapper.getNewToken();
        String token ="Bearer eyJhbGciOiJIUzUxMiJ9.eyJ1c2VyX2lkIjoxLCJ1c2VyX2tleSI6IjUwZTU1NTRkLWJjYzYtNGRhMS1iZDUxLWFhNTc3YzU4YTFiNCIsInVzZXJuYW1lIjoiYWRtaW4ifQ.X10VPYJfeeRTka7OtqNPOGMpL4QkW3fR_TfCKXCmO-yXbIIrr_40fcwiVnpXfYVENo_BvXWEACRd-Y6nXsbkog";
        if(tokenMap!=null){
            token = "Bearer "+tokenMap.get("token");
        }
        // 创建一个请求头对象
        HttpHeaders httpHeaders = new HttpHeaders();
        // 设置参数
        httpHeaders.set("authorization", token);
        // 创建一个响应体对象
        HttpEntity<String> httpEntity = new HttpEntity(httpHeaders);
        // 3.创建RestTemplate
        RestTemplate restTemplate = new RestTemplate();
        // 发送GET请求
        ResponseEntity<Map> responseEntity = restTemplate.exchange(BUILDING_STATION_URL, HttpMethod.GET, httpEntity, Map.class);
        // 获取响应对象里的 body 对象
        Map<String, Object> body = responseEntity.getBody();
        // 获取状态码
        Integer code = (Integer)body.get("code");
        // 获取响应信息
        String message = (String)body.get("msg");
        if(code==200){
            ArrayList list = (ArrayList) body.get("rows");
            if(list!=null&&list.size()>0){
                buildingStationMapper.delete(null);
                for (int i=0;i<list.size();i++){
                    LinkedHashMap json = (LinkedHashMap) list.get(i);
                    BuildingStation station = new BuildingStation();
                    station.setId((Integer) json.get("id"));
                    station.setCode(String.valueOf(json.get("code")));
                    if(json.get("officeId")!=null){
                        station.setDeptId(Integer.parseInt(String.valueOf(json.get("officeId"))));
                    }
                    if(json.get("roomId")!=null){
                        station.setRoomId(Integer.parseInt(String.valueOf(json.get("roomId"))));
                    }
                   // station.setDeptId(Integer.parseInt(String.valueOf(json.get("officeId"))));
                    station.setStatus(Integer.parseInt(String.valueOf(json.get("status"))));
                    station.setIsDel(Integer.parseInt(String.valueOf(json.get("delFlag"))));

                    station.setType(String.valueOf(json.get("type")));
                    station.setCreateTime(String.valueOf(json.get("createTime")));
                    station.setUpdateTime(String.valueOf(json.get("updateTime")));
                    station.setIsBlock(Integer.parseInt(String.valueOf(json.get("isBlock"))));
                    buildingStationMapper.insert(station);
                }
            }
            return ReturnMsg.ok();
        }else{
            log.info("获取工位数据："+message);
            return ReturnMsg.fail(message);
        }
    }
}
